/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "deg2nm.h"
#include "almanac.h"
#include "deg2km.h"
#include "km2nm.h"
#include "libmatlbm.h"
#include "nm2km.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[5] = { 'e', 'a', 'r', 't', 'h' };
static mxArray * _mxarray2_;

static mxChar _array5_[6] = { 'r', 'a', 'd', 'i', 'u', 's' };
static mxArray * _mxarray4_;

static mxChar _array7_[2] = { 'k', 'm' };
static mxArray * _mxarray6_;

void InitializeModule_deg2nm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(5, _array3_);
    _mxarray4_ = mclInitializeString(6, _array5_);
    _mxarray6_ = mclInitializeString(2, _array7_);
}

void TerminateModule_deg2nm(void) {
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdeg2nm(int nargout_, mxArray * deg, mxArray * radius);

_mexLocalFunctionTable _local_function_table_deg2nm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDeg2nm" contains the normal interface for the "deg2nm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2nm.m" (lines 1-32).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDeg2nm(mxArray * deg, mxArray * radius) {
    int nargout = 1;
    mxArray * nm = NULL;
    mlfEnterNewContext(0, 2, deg, radius);
    nm = Mdeg2nm(nargout, deg, radius);
    mlfRestorePreviousContext(0, 2, deg, radius);
    return mlfReturnValue(nm);
}

/*
 * The function "mlxDeg2nm" contains the feval interface for the "deg2nm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2nm.m" (lines 1-32).
 * The feval function calls the implementation version of deg2nm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDeg2nm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: deg2nm Line: 1 Column: "
            "1 The function \"deg2nm\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: deg2nm Line: 1 Column: "
            "1 The function \"deg2nm\" was called with mor"
            "e than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mdeg2nm(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdeg2nm" is the implementation version of the "deg2nm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2nm.m" (lines 1-32).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function nm = deg2nm(deg,radius)
 */
static mxArray * Mdeg2nm(int nargout_, mxArray * deg, mxArray * radius) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_deg2nm);
    int nargin_ = mclNargin(2, deg, radius, NULL);
    mxArray * nm = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&deg);
    mclCopyArray(&radius);
    /*
     * 
     * %DEG2NM Converts distances from degrees to nautical miles
     * %
     * %  nm = DEG2NM(deg) converts distances from degrees to nautical miles.
     * %  A degree of distance is measured along a great circle of a sphere.
     * %
     * %  nm = DEG2NM(deg,radius) uses the second input to determine the
     * %  radius of the sphere.  If radius is a string, then it is evaluated
     * %  as an ALMANAC body to determine the spherical radius.  If numerical,
     * %  it is the radius of the desired sphere in nautical miles.  If omitted,
     * %  the default radius of the Earth is used.
     * %
     * %  See also NM2DEG, DEG2RAD, DEG2KM, DEG2SM, DISTDIM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Brown, E. Byrns
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:24:59 $
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * radius = almanac('earth','radius','km');
         */
        mlfAssign(
          &radius, mlfAlmanac(_mxarray2_, _mxarray4_, _mxarray6_, NULL));
    /*
     * elseif nargin == 2 & isstr(radius)
     */
    } else {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ == 2));
        if (mlfTobool(a_)
            && mlfTobool(mclAnd(a_, mlfIsstr(mclVa(radius, "radius"))))) {
            mxDestroyArray(a_);
            /*
             * radius = almanac(radius,'radius','km');
             */
            mlfAssign(
              &radius,
              mlfAlmanac(
                mclVa(radius, "radius"), _mxarray4_, _mxarray6_, NULL));
        /*
         * elseif nargin == 2 & ~isstr(radius)
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_0 = mclInitialize(mclBoolToArray(nargin_ == 2));
                if (mlfTobool(a_0)
                    && mlfTobool(
                         mclAnd(
                           a_0, mclNot(mlfIsstr(mclVa(radius, "radius")))))) {
                    mxDestroyArray(a_0);
                    /*
                     * radius = nm2km(radius);
                     */
                    mlfAssign(&radius, mlfNm2km(mclVa(radius, "radius")));
                } else {
                    mxDestroyArray(a_0);
                }
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     * 
     * nm = km2nm(deg2km(deg,radius) );
     */
    mlfAssign(
      &nm, mlfKm2nm(mlfDeg2km(mclVa(deg, "deg"), mclVa(radius, "radius"))));
    mclValidateOutput(nm, 1, nargout_, "nm", "deg2nm");
    mxDestroyArray(ans);
    mxDestroyArray(radius);
    mxDestroyArray(deg);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return nm;
}
