/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "dms2dm.h"
#include "dms2mat.h"
#include "libmatlbm.h"
#include "mat2dms.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

void InitializeModule_dms2dm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDouble(.2);
}

void TerminateModule_dms2dm(void) {
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdms2dm(int nargout_, mxArray * dms);

_mexLocalFunctionTable _local_function_table_dms2dm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDms2dm" contains the normal interface for the "dms2dm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2dm.m" (lines 1-31).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDms2dm(mxArray * dms) {
    int nargout = 1;
    mxArray * dm = NULL;
    mlfEnterNewContext(0, 1, dms);
    dm = Mdms2dm(nargout, dms);
    mlfRestorePreviousContext(0, 1, dms);
    return mlfReturnValue(dm);
}

/*
 * The function "mlxDms2dm" contains the feval interface for the "dms2dm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2dm.m" (lines 1-31).
 * The feval function calls the implementation version of dms2dm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDms2dm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: dms2dm Line: 1 Column: "
            "1 The function \"dms2dm\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: dms2dm Line: 1 Column: "
            "1 The function \"dms2dm\" was called with mor"
            "e than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mdms2dm(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdms2dm" is the implementation version of the "dms2dm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2dm.m" (lines 1-31).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function dm=dms2dm(dms)
 */
static mxArray * Mdms2dm(int nargout_, mxArray * dms) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_dms2dm);
    int nargin_ = mclNargin(1, dms, NULL);
    mxArray * dm = NULL;
    mxArray * s = NULL;
    mxArray * m = NULL;
    mxArray * d = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&dms);
    /*
     * 
     * %DMS2DM Converts angles from deg:min:sec to deg:min vector format
     * %
     * %  dm = DMS2DM(dms) converts from the deg:min:sec vector format
     * %  to deg:min vector format.  Seconds are rounded to the nearest
     * %  minute.
     * %
     * %  See also DMS2DEG,  MAT2DMS, DMS2MAT, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:06 $
     * 
     * 
     * if nargin==0;   error('Incorrect number of arguments');   end
     */
    if (nargin_ == 0) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * %  Do all the error checking on dms format first.
     * 
     * [d,m,s]=dms2mat(dms);
     */
    mlfAssign(&d, mlfNDms2mat(3, &m, &s, mclVa(dms, "dms"), NULL));
    /*
     * 
     * %  Now, round the (valid) dms entry and then build up the dm output.
     * %
     * %  0.2 is used to round seconds.  0.3+0.2 = 0.5 which will round up
     * %  to an additional minute.  0.29+0.2 = 0.49 which will stay at
     * %  the current minute.
     * 
     * dms = round(dms+0.2);
     */
    mlfAssign(&dms, mlfRound(mclPlus(mclVa(dms, "dms"), _mxarray2_)));
    /*
     * [d,m,s] = dms2mat(dms);
     */
    mlfAssign(&d, mlfNDms2mat(3, &m, &s, mclVa(dms, "dms"), NULL));
    /*
     * dm = mat2dms(d,m);     %  Round 60 minutes to 1 degree here
     */
    mlfAssign(&dm, mlfMat2dms(mclVv(d, "d"), mclVv(m, "m"), NULL, NULL));
    mclValidateOutput(dm, 1, nargout_, "dm", "dms2dm");
    mxDestroyArray(ans);
    mxDestroyArray(d);
    mxDestroyArray(m);
    mxDestroyArray(s);
    mxDestroyArray(dms);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return dm;
}
