/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "dms2rad.h"
#include "deg2rad.h"
#include "dms2deg.h"
#include "dms2mat.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

void InitializeModule_dms2rad(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
}

void TerminateModule_dms2rad(void) {
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdms2rad(int nargout_,
                          mxArray * dms,
                          mxArray * in2,
                          mxArray * in3);

_mexLocalFunctionTable _local_function_table_dms2rad
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDms2rad" contains the normal interface for the "dms2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2rad.m" (lines 1-30).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDms2rad(mxArray * dms, mxArray * in2, mxArray * in3) {
    int nargout = 1;
    mxArray * rad = NULL;
    mlfEnterNewContext(0, 3, dms, in2, in3);
    rad = Mdms2rad(nargout, dms, in2, in3);
    mlfRestorePreviousContext(0, 3, dms, in2, in3);
    return mlfReturnValue(rad);
}

/*
 * The function "mlxDms2rad" contains the feval interface for the "dms2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2rad.m" (lines 1-30).
 * The feval function calls the implementation version of dms2rad through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDms2rad(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: dms2rad Line: 1 Column: "
            "1 The function \"dms2rad\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: dms2rad Line: 1 Column:"
            " 1 The function \"dms2rad\" was called with m"
            "ore than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mdms2rad(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdms2rad" is the implementation version of the "dms2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2rad.m" (lines 1-30).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function rad=dms2rad(dms, in2, in3)
 */
static mxArray * Mdms2rad(int nargout_,
                          mxArray * dms,
                          mxArray * in2,
                          mxArray * in3) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_dms2rad);
    int nargin_ = mclNargin(3, dms, in2, in3, NULL);
    mxArray * rad = NULL;
    mxArray * s = NULL;
    mxArray * m = NULL;
    mxArray * d = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&dms);
    mclCopyArray(&in2);
    mclCopyArray(&in3);
    /*
     * 
     * %DMS2RAD Converts angles from deg:min:sec to radians
     * %
     * %  rad = DMS2RAD(dms) converts from the deg:min:sec vector format
     * %  to radians.
     * %
     * %  rad = DMS2RAD(d,m,s) converts from degree (d), minute (m) and
     * %  second (s) format to radians.  The input matrices d, m and s must
     * %  be of equal size.  Minutes and seconds must be between 0 and 60.
     * %
     * %  See also RAD2DMS, DMS2DEG, MAT2DMS, DMS2MAT, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:07 $
     * 
     * 
     * if nargin == 0 | nargin == 2
     */
    if (nargin_ == 0 || nargin_ == 2) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * [d,m,s] = dms2mat(dms);
         */
        mlfAssign(&d, mlfNDms2mat(3, &m, &s, mclVa(dms, "dms"), NULL));
    /*
     * elseif nargin == 3
     */
    } else if (nargin_ == 3) {
        /*
         * d = dms;   m = in2;    s = in3;
         */
        mlfAssign(&d, mclVa(dms, "dms"));
        mlfAssign(&m, mclVa(in2, "in2"));
        mlfAssign(&s, mclVa(in3, "in3"));
    /*
     * end
     */
    }
    /*
     * 
     * %  Compute the angle in radians by first transforming from dms to degrees.
     * 
     * rad = deg2rad(dms2deg(d,m,s));
     */
    mlfAssign(
      &rad,
      mlfDeg2rad(mlfDms2deg(mclVv(d, "d"), mclVv(m, "m"), mclVv(s, "s"))));
    mclValidateOutput(rad, 1, nargout_, "rad", "dms2rad");
    mxDestroyArray(ans);
    mxDestroyArray(d);
    mxDestroyArray(m);
    mxDestroyArray(s);
    mxDestroyArray(in3);
    mxDestroyArray(in2);
    mxDestroyArray(dms);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return rad;
}
