/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "epsm.h"
#include "angledim.h"
#include "libmatlbm.h"
#include "unitstr.h"
static mxArray * _mxarray0_;

static mxChar _array2_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray1_;

static mxChar _array4_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray3_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;

static mxChar _array8_[6] = { 'a', 'n', 'g', 'l', 'e', 's' };
static mxArray * _mxarray7_;

void InitializeModule_epsm(void) {
    _mxarray0_ = mclInitializeDouble(1e-06);
    _mxarray1_ = mclInitializeString(7, _array2_);
    _mxarray3_ = mclInitializeString(7, _array4_);
    _mxarray5_ = mclInitializeDouble(3.141592653589793);
    _mxarray6_ = mclInitializeDouble(180.0);
    _mxarray7_ = mclInitializeString(6, _array8_);
}

void TerminateModule_epsm(void) {
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mepsm(int nargout_, mxArray * units);

_mexLocalFunctionTable _local_function_table_epsm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfEpsm" contains the normal interface for the "epsm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\epsm.m" (lines 1-37).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfEpsm(mxArray * units) {
    int nargout = 1;
    mxArray * epsilon = NULL;
    mlfEnterNewContext(0, 1, units);
    epsilon = Mepsm(nargout, units);
    mlfRestorePreviousContext(0, 1, units);
    return mlfReturnValue(epsilon);
}

/*
 * The function "mlxEpsm" contains the feval interface for the "epsm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\epsm.m" (lines 1-37). The
 * feval function calls the implementation version of epsm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxEpsm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: epsm Line: 1 Column: 1 The function \"epsm\""
            " was called with more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: epsm Line: 1 Column: 1 The function \"epsm"
            "\" was called with more than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mepsm(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mepsm" is the implementation version of the "epsm" M-function
 * from file "c:\matlab6p5\toolbox\map\map\epsm.m" (lines 1-37). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function epsilon = epsm(units)
 */
static mxArray * Mepsm(int nargout_, mxArray * units) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_epsm);
    int nargin_ = mclNargin(1, units, NULL);
    mxArray * epsilon = NULL;
    mxArray * ans = NULL;
    mxArray * msg = NULL;
    mxArray * degepsilon = NULL;
    mclCopyArray(&units);
    /*
     * 
     * %EPSM  Calculate the accuracy of the map computations
     * %
     * %  e = EPSM returns the accuracy of computations performed in
     * %  the Mapping Toolbox.  The accuracy returned is in degrees.
     * %
     * %  e = EPSM('units') returns the accuracy in the units specified
     * %  by the string 'units'.  If omitted, 'degrees' are assumed.
     * %
     * %  See also EPS
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:14 $
     * 
     * %  Define the limit in degrees
     * 
     * degepsilon = 1.0E-6;
     */
    mlfAssign(&degepsilon, _mxarray0_);
    /*
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * epsilon = degepsilon;   return
         */
        mlfAssign(&epsilon, mclVv(degepsilon, "degepsilon"));
    /*
     * 
     * %  Speed up function with special unit string tests
     * 
     * elseif strcmp(units,'degrees')
     */
    } else if (mlfTobool(mlfStrcmp(mclVa(units, "units"), _mxarray1_))) {
        /*
         * epsilon = degepsilon;   return
         */
        mlfAssign(&epsilon, mclVv(degepsilon, "degepsilon"));
    /*
     * 
     * elseif strcmp(units,'radians')
     */
    } else if (mlfTobool(mlfStrcmp(mclVa(units, "units"), _mxarray3_))) {
        /*
         * epsilon = degepsilon*pi/180;   return
         */
        mlfAssign(
          &epsilon,
          mclMrdivide(
            mclMtimes(mclVv(degepsilon, "degepsilon"), _mxarray5_),
            _mxarray6_));
    /*
     * 
     * else
     */
    } else {
        /*
         * [units,msg] = unitstr(units,'angles');
         */
        mlfAssign(
          &units, mlfNUnitstr(2, &msg, mclVa(units, "units"), _mxarray7_));
        /*
         * if ~isempty(msg);   error(msg);   end
         */
        if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
            mlfError(mclVv(msg, "msg"), NULL);
        }
        /*
         * epsilon = angledim(degepsilon,'degrees',units);
         */
        mlfAssign(
          &epsilon,
          mlfAngledim(
            mclVv(degepsilon, "degepsilon"),
            _mxarray1_,
            mclVa(units, "units")));
    /*
     * end
     */
    }
    mclValidateOutput(epsilon, 1, nargout_, "epsilon", "epsm");
    mxDestroyArray(degepsilon);
    mxDestroyArray(msg);
    mxDestroyArray(ans);
    mxDestroyArray(units);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return epsilon;
}
