/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "rad2dm.h"
#include "dms2mat.h"
#include "libmatlbm.h"
#include "mat2dms.h"
#include "rad2dms.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

void InitializeModule_rad2dm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDouble(.2);
}

void TerminateModule_rad2dm(void) {
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mrad2dm(int nargout_, mxArray * rad);

_mexLocalFunctionTable _local_function_table_rad2dm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfRad2dm" contains the normal interface for the "rad2dm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2dm.m" (lines 1-24).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfRad2dm(mxArray * rad) {
    int nargout = 1;
    mxArray * dm = NULL;
    mlfEnterNewContext(0, 1, rad);
    dm = Mrad2dm(nargout, rad);
    mlfRestorePreviousContext(0, 1, rad);
    return mlfReturnValue(dm);
}

/*
 * The function "mlxRad2dm" contains the feval interface for the "rad2dm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2dm.m" (lines 1-24).
 * The feval function calls the implementation version of rad2dm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxRad2dm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2dm Line: 1 Column: "
            "1 The function \"rad2dm\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2dm Line: 1 Column: "
            "1 The function \"rad2dm\" was called with mor"
            "e than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mrad2dm(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mrad2dm" is the implementation version of the "rad2dm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2dm.m" (lines 1-24).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function dm=rad2dm(rad)
 */
static mxArray * Mrad2dm(int nargout_, mxArray * rad) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_rad2dm);
    int nargin_ = mclNargin(1, rad, NULL);
    mxArray * dm = NULL;
    mxArray * s = NULL;
    mxArray * m = NULL;
    mxArray * d = NULL;
    mxArray * dms = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&rad);
    /*
     * 
     * %RAD2DM Converts angles from radians to deg:min vector format
     * %
     * %  dm = RAD2DM(rad) converts angles from radians to deg:min vector
     * %  format.  The angle is rounded to the nearest minute.
     * %
     * %  See also DM2RAD, DMS2RAD, RAD2DMS, MAT2DMS, DMS2MAT, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:26:12 $
     * 
     * if nargin==0;   error('Incorrect number of arguments');   end
     */
    if (nargin_ == 0) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * %  Compute the angle in dm.
     * %  0.2 is used to round seconds.  0.3+0.2 = 0.5 which will round up
     * %  to an additional minute.  0.29+0.2 = 0.49 which will stay at
     * %  the curren minute.
     * 
     * dms = round(rad2dms(rad)+0.2);
     */
    mlfAssign(
      &dms, mlfRound(mclPlus(mlfRad2dms(mclVa(rad, "rad")), _mxarray2_)));
    /*
     * [d,m,s] = dms2mat(dms);
     */
    mlfAssign(&d, mlfNDms2mat(3, &m, &s, mclVv(dms, "dms"), NULL));
    /*
     * dm = mat2dms(d,m);         %  Round 60 minutes to 1 degree here
     */
    mlfAssign(&dm, mlfMat2dms(mclVv(d, "d"), mclVv(m, "m"), NULL, NULL));
    mclValidateOutput(dm, 1, nargout_, "dm", "rad2dm");
    mxDestroyArray(ans);
    mxDestroyArray(dms);
    mxDestroyArray(d);
    mxDestroyArray(m);
    mxDestroyArray(s);
    mxDestroyArray(rad);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return dm;
}
