/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "sm2rad.h"
#include "almanac.h"
#include "km2rad.h"
#include "libmatlbm.h"
#include "sm2km.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[5] = { 'e', 'a', 'r', 't', 'h' };
static mxArray * _mxarray2_;

static mxChar _array5_[6] = { 'r', 'a', 'd', 'i', 'u', 's' };
static mxArray * _mxarray4_;

static mxChar _array7_[2] = { 'k', 'm' };
static mxArray * _mxarray6_;

void InitializeModule_sm2rad(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(5, _array3_);
    _mxarray4_ = mclInitializeString(6, _array5_);
    _mxarray6_ = mclInitializeString(2, _array7_);
}

void TerminateModule_sm2rad(void) {
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Msm2rad(int nargout_, mxArray * sm, mxArray * radius);

_mexLocalFunctionTable _local_function_table_sm2rad
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfSm2rad" contains the normal interface for the "sm2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\sm2rad.m" (lines 1-32).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfSm2rad(mxArray * sm, mxArray * radius) {
    int nargout = 1;
    mxArray * rad = NULL;
    mlfEnterNewContext(0, 2, sm, radius);
    rad = Msm2rad(nargout, sm, radius);
    mlfRestorePreviousContext(0, 2, sm, radius);
    return mlfReturnValue(rad);
}

/*
 * The function "mlxSm2rad" contains the feval interface for the "sm2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\sm2rad.m" (lines 1-32).
 * The feval function calls the implementation version of sm2rad through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxSm2rad(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sm2rad Line: 1 Column: "
            "1 The function \"sm2rad\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sm2rad Line: 1 Column: "
            "1 The function \"sm2rad\" was called with mor"
            "e than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Msm2rad(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Msm2rad" is the implementation version of the "sm2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\sm2rad.m" (lines 1-32).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function rad=sm2rad(sm,radius)
 */
static mxArray * Msm2rad(int nargout_, mxArray * sm, mxArray * radius) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_sm2rad);
    int nargin_ = mclNargin(2, sm, radius, NULL);
    mxArray * rad = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&sm);
    mclCopyArray(&radius);
    /*
     * 
     * %SM2RAD Converts distances from statute miles to radians
     * %
     * %  rad = SM2RAD(sm) converts distances from statute miles to radians.
     * %  A radian of distance is measured along a great circle of a sphere.
     * %
     * %  rad = SM2RAD(sm,radius) uses the second input to determine the
     * %  radius of the sphere.  If radius is a string, then it is evaluated
     * %  as an ALMANAC body to determine the spherical radius.  If numerical,
     * %  it is the radius of the desired sphere in statute miles.  If omitted,
     * %  the default radius of the Earth is used.
     * %
     * %  See also RAD2SM, SM2DEG, SM2NM, SM2SM, DISTDIM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Brown, E. Byrns
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:26:26 $
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * radius = almanac('earth','radius','km');
         */
        mlfAssign(
          &radius, mlfAlmanac(_mxarray2_, _mxarray4_, _mxarray6_, NULL));
    /*
     * elseif nargin == 2 & isstr(radius)
     */
    } else {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ == 2));
        if (mlfTobool(a_)
            && mlfTobool(mclAnd(a_, mlfIsstr(mclVa(radius, "radius"))))) {
            mxDestroyArray(a_);
            /*
             * radius = almanac(radius,'radius','km');
             */
            mlfAssign(
              &radius,
              mlfAlmanac(
                mclVa(radius, "radius"), _mxarray4_, _mxarray6_, NULL));
        /*
         * elseif nargin == 2 & ~isstr(radius)
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_0 = mclInitialize(mclBoolToArray(nargin_ == 2));
                if (mlfTobool(a_0)
                    && mlfTobool(
                         mclAnd(
                           a_0, mclNot(mlfIsstr(mclVa(radius, "radius")))))) {
                    mxDestroyArray(a_0);
                    /*
                     * radius = sm2km(radius);
                     */
                    mlfAssign(&radius, mlfSm2km(mclVa(radius, "radius")));
                } else {
                    mxDestroyArray(a_0);
                }
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     * 
     * rad = km2rad(sm2km(sm),radius);
     */
    mlfAssign(
      &rad, mlfKm2rad(mlfSm2km(mclVa(sm, "sm")), mclVa(radius, "radius")));
    mclValidateOutput(rad, 1, nargout_, "rad", "sm2rad");
    mxDestroyArray(ans);
    mxDestroyArray(radius);
    mxDestroyArray(sm);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return rad;
}
