function varargout = traj(varargin)
% TRAJ Application M-file for traj.fig
%    FIG = TRAJ launch traj GUI.
%    TRAJ('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 29-Jun-2004 23:18:14



if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');
 
	% Use system color scheme for figure and figure position
    set(0,'Units','characters')
    scnsize = get(0,'ScreenSize');
    figure_length=172;
    figure_height=45;
    left_border=(scnsize(3)-figure_length)*.5;
    bottom_border=(scnsize(4)-figure_height)*.5;
    figure_position=[left_border bottom_border figure_length figure_height];
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'),'Position',figure_position, ...
        'doublebuffer','on','ShareColor','off','CreateFcn','movegui');
    hgsave(fig,'onscreenfig');
    close(fig)
    fig=hgload('onscreenfig');


	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);

%=================================================================================================================                      
    % Define input information in additional handles;
%===> 0
set(handles.figure1,'Name','Visualization');
set(handles.CurrentYear,'String','Year');                     % year of current date
set(handles.CurrentDate,'String','Day/Month');                % day/month of current date
set(handles.axes1,'Visible','Off','DrawMode','Fast');         % turn off axes
set(handles.LIST,'Visible','Off','DrawMode','Fast')
%handles.K=72;

%===> 1    
handles.m=[87 88 89 90 91 92 1:16 19:22 24 26 28:33 35 37:39 41:46 48:51 53 55 58 62:69 71:75 79:85];
handles.M_buy=length(handles.m);
handles.N_buy=1:handles.M_buy;
for k=handles.N_buy,
    handles.T{k}=num2str(handles.m(k));
end;
set(handles.BuoyList,'String',handles.T);

handles.SELS=2.e-3;
handles.AXIS_strela=5.;
handles.MULTI_ellipse=2;
handles.AXIS_ellipse=handles.AXIS_strela*handles.MULTI_ellipse;
handles.LATS_control=48;
handles.LONS_control=-133;
handles.chisloA=0.01;


%===> 2
handles.DATA_MINUS=datenum(1992,01,01,0,0,0);                            
N_basa=0;
for k_year=1992:2004,
    for k_month=1:12,        
        for k_day=1:eomday(k_year,k_month);
            N_basa=N_basa+1;
            DATAS_basa(N_basa)=datenum(k_year,k_month,k_day,0,0,0)-handles.DATA_MINUS;
        end;
    end;
end;
handles.M_day=length(DATAS_basa);
handles.M_hour=24;
handles.MONTHS={
    ' January   ',
    ' February  ',
    ' March     ',
    ' April     ',
    ' May       ',
    ' June      ',
    ' July      ',
    ' August    ',
    ' September ',
    ' October   ',
    ' November  ',
    ' December  '};


%===> 4
load trajectories_data

load graniza001
handles.SLOall=SLOall; clear SLOall;
handles.SLO100=SLO100; clear SLO100;
handles.SLO500=SLO500; clear SLO500;
handles.SLO1000=SLO1000; clear SLO1000;
handles.GRAN1=GRAN1; clear GRAN1;
handles.GRAN2=GRAN2; clear GRAN2;                

load graniza002
handles.XY=XY;

%===> dop



%===> 5
axes(handles.axes1)
set(handles.axes1,'Visible','On') 
basa_coast_old(handles.SLOall, handles.SLO100, handles.SLO500, handles.SLO1000, handles.GRAN1, handles.GRAN2,handles.XY)
hold on


hhhh=waitbar(0,'Please wait...');


for k=1:handles.M_buy,
    [Traj_data{k}(:,2),Traj_data{k}(:,3)]=mfwdtran(Traj_data{k}(:,2),Traj_data{k}(:,3));
    [Traj_data{k}(:,4),Traj_data{k}(:,5)]=mfwdtran(Traj_data{k}(:,4),Traj_data{k}(:,5));
    ijk=find(Traj_data{k}(:,1)~=1);
    Traj_data{k}(ijk,2)=NaN;
    Traj_data{k}(ijk,3)=NaN;
    waitbar(k./handles.M_buy)
end;

close(hhhh)


handles.Traj_data=Traj_data;
handles.Traj_time=Traj_time;

axes(handles.LIST)
set(handles.LIST,'Visible','On','XTick',[],'YTick',[],'XColor','w','YColor','w','YLim',[-0.1 1.1])


for k=1:round(handles.M_buy/2),
    handles.text(k)=text(0.35,1-2*k./handles.M_buy,int2str(handles.m(k)));
    set(handles.text(k),'Color',[.7 .7 .7],'FontSize',7);    
    hold on
end;

for k=round(handles.M_buy/2)+1:handles.M_buy,
    handles.text(k)=text(0.7,1-2*(k-round(handles.M_buy/2))./handles.M_buy,int2str(handles.m(k)));
    set(handles.text(k),'Color',[.7 .7 .7],'FontSize',7);
    hold on
end;

axes(handles.axes1)

%===> 6
handles.Colormap_names={...
    'hsv';
    'hot';
    'gray';
    'bone';
    'copper';
    'pink';
    'white';
    'flag';
    'lines';
    'colorcube';
    'vga';
    'jet';
    'prism';
    'cool';
    'autumn';
    'spring';
    'winter';
    'summer'};

Slider_range_temp=[0 20]; Arrow_step_temp=0.1; Trough_step_temp=1;
slider_step_temp(1)=Arrow_step_temp/diff(Slider_range_temp);
slider_step_temp(2)=Trough_step_temp/diff(Slider_range_temp);
set(handles.temperature_minimum,'sliderstep',slider_step_temp,...
      'max',Slider_range_temp(2),'min',Slider_range_temp(1),'Value',Slider_range_temp(1));
set(handles.temperature_maximum,'sliderstep',slider_step_temp,...
      'max',Slider_range_temp(2),'min',Slider_range_temp(1),'Value',Slider_range_temp(2));
set(handles.temperature_edit_min,'Value',Slider_range_temp(1));
set(handles.temperature_edit_max,'Value',Slider_range_temp(2));
    

Slider_range_pres=[0 5000]; Arrow_step_pres=0.1; Trough_step_pres=1;
slider_step_pres(1)=Arrow_step_pres/diff(Slider_range_pres);
slider_step_pres(2)=Trough_step_pres/diff(Slider_range_pres);
set(handles.pressure_minimum,'sliderstep',slider_step_pres,...
      'max',Slider_range_pres(2),'min',Slider_range_pres(1),'Value',Slider_range_pres(1));
set(handles.pressure_maximum,'sliderstep',slider_step_pres,...
      'max',Slider_range_pres(2),'min',Slider_range_pres(1),'Value',Slider_range_pres(2));
set(handles.pressure_edit_min,'Value',Slider_range_pres(1));
set(handles.pressure_edit_max,'Value',Slider_range_pres(2));

%===> 7
handles.NoColor=[0 0 0];

handles.PP=zeros(handles.M_buy,2);
handles.PRE=[];
for k=handles.N_buy,
    handles.PP(k,1)=length(handles.PRE)+1;
    handles.PRE=[handles.PRE; handles.Traj_data{k}(:,7)];
    handles.PP(k,2)=length(handles.PRE);       
end;
handles.PRE=handles.PRE';

handles.TT=zeros(handles.M_buy,2);
handles.TEM=[];
for k=handles.N_buy,
    handles.TT(k,1)=length(handles.TEM)+1;
    handles.TEM=[handles.TEM; handles.Traj_data{k}(:,6)];
    handles.TT(k,2)=length(handles.TEM);       
end;
handles.TEM=handles.TEM';

%=================================================================================================================                  
   
guidata(fig, handles);

if nargout > 0
    varargout{1} = fig;
end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end



% --------------------------------------------------------------------
function varargout = CurrentYear_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CurrentYear.
%disp('CurrentYear Callback not implemented yet.')

% --------------------------------------------------------------------
function varargout = CurrentDate_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.CurrentDate.
%disp('CurrentDate Callback not implemented yet.')

% --------------------------------------------------------------------
function varargout = PushStart_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PushStart.
%disp('PushStart Callback not implemented yet.')

if get(handles.SpeedLow,'Value')==1,
    handles.K=24;
else
    handles.K=72;
end;


axes(handles.axes1)

hour_all=1:24;

tr=get(handles.axes1,'Visible');
if strcmpi(tr,'Off'),
    set(handles.axes1,'Visible','On') 
    basa_coast_old(handles.SLOall, handles.SLO100, handles.SLO500, handles.SLO1000, handles.GRAN1, handles.GRAN2,handles.XY)
    hold on
    p_ell=50;                                % number of points along the base circumference
theta=(0:p_ell)/p_ell*2*pi;  
theta_axis01=[0 pi];
theta_axis02=[pi/2 3.*pi./2];

[handles.X_control,handles.Y_control]=mfwdtran(handles.LATS_control,handles.LONS_control);
handles.x_control=handles.SELS.*handles.AXIS_ellipse.*cos(theta)+handles.X_control;
handles.y_control=handles.SELS.*handles.AXIS_ellipse.*sin(theta)+handles.Y_control;
handles.x_control01=[handles.X_control-handles.SELS.*handles.AXIS_ellipse handles.X_control];
handles.y_control01=[handles.Y_control handles.Y_control];
handles.y_control02=[handles.Y_control handles.SELS.*handles.AXIS_ellipse+handles.Y_control];
handles.x_control02=[handles.X_control handles.X_control];

fill(handles.x_control,handles.y_control,[.7 .7 .7]);
plot(handles.x_control01,handles.y_control01,'k')
plot(handles.x_control02,handles.y_control02,'k')
plot(handles.X_control,handles.Y_control,'ko','MarkerSize',3,'MarkerFaceColor','w')
handles.LATtext=48.5;
handles.LONtext=-131.5;
[handles.Xtext,handles.Ytext]=mfwdtran(handles.LATtext,handles.LONtext);
text(handles.Xtext,handles.Ytext,'5 cm/sec')
[STRELAx,STRELAy]=strelka(handles.X_control,handles.Y_control,handles.AXIS_strela,0,handles.chisloA,0.25,20);
arr0=line('Color','k','LineStyle','-','Erase','none','LineWidth',1,...
    'XData',STRELAx,'YData',STRELAy);


end;

trt=get(handles.SelectBuoy,'Value');

if get(handles.colormap_colorbar,'Value')==1,
    ColorNumber=13:15;
else
    ColorNumber=16:18;
end;

if trt==0, % visualization by date


p=[];

handles.Month_start=get(handles.StartMonth,'Value');
handles.Day_start=str2num(get(handles.StartDay,'String'));
handles.Year_start=get(handles.StartYear,'Value')+1991;
handles.Month_final=get(handles.FinishMonth,'Value');
handles.Day_final=str2num(get(handles.FinishDay,'String'));
handles.Year_final=get(handles.FinishYear,'Value')+1991;

head=zeros(handles.M_buy,1);
body=zeros(handles.M_buy,1);
CONTROL=zeros(handles.M_buy,1);
if get(handles.SelectRegion,'Value')==1,
    chislo=1;
    U=[]; V=[]; W=[];
    ell=line('Color','k','LineStyle','-','Erase','xor','LineWidth',1,...
        'XData',[],'YData',[]);     
    arr=line('Color','k','LineStyle','-','Erase','xor','LineWidth',2,...
        'XData',[],'YData',[]);
    
end;
p_ell=50;                                % number of points along the base circumference
theta=(0:p_ell)/p_ell*2*pi;  
theta_axis01=[0 pi];
theta_axis02=[pi/2 3.*pi./2];

N_start=datenum(handles.Year_start,handles.Month_start,handles.Day_start,0,0,0)-handles.DATA_MINUS+1;
N_finish=datenum(handles.Year_final,handles.Month_final,handles.Day_final,0,0,0)-handles.DATA_MINUS+1;
N_start=handles.M_hour*(N_start-1)+1;
N_finish=handles.M_hour*(N_finish-1)+24;
TIMEall=N_finish-N_start+1;
handles.Buoy_start=zeros(handles.M_buy,1);
handles.Buoy_finish=zeros(handles.M_buy,1);
XX0=cell(handles.M_buy,1); YY0=cell(handles.M_buy,1);
XXX=cell(handles.M_buy,1); YYY=cell(handles.M_buy,1);

k_hour_start=1;
if get(handles.SelectRegion,'Value')==1,
    k_hour_finish=24;
    k_hour_shag=12;
else
    k_hour_finish=1;
    k_hour_shag=1;
end;

for k=handles.N_buy,
    set(handles.text(k),'Color',[.7 .7 .7]);
end;


for k=handles.Year_start:handles.Year_final, % year-loop
    txt=int2str(k);        
    set(handles.CurrentYear,'String',txt)
    if k==handles.Year_start,
        Month_start=handles.Month_start;
    else
        Month_start=1;
    end;
    if k==handles.Year_final,
        Month_final=handles.Month_final;
    else
        Month_final=12;
    end;
    for k_month=Month_start:Month_final,        % month-loop
        xtx1=handles.MONTHS{k_month};
        if ((k==handles.Year_start)&(k_month==handles.Month_start)),
            Day_start=handles.Day_start;
        else
            Day_start=1;
        end;
        
        if ((k==handles.Year_final)&(k_month==handles.Month_final)),
            Day_final=handles.Day_final;
        else
            Day_final=eomday(k,k_month);
        end;
        
        for k_day=Day_start:round(handles.K./24):Day_final;      % day-loop
            xtx2=int2str(k_day);
            if k_day<10,
                xtx2=['0' xtx2];
            end;
            xtx=[xtx1 ' ' xtx2];
            set(handles.CurrentDate,'String',xtx)
            
            kk=datenum(k,k_month,k_day,0,0,0)-handles.DATA_MINUS+1;                                    
            nn=handles.M_hour*(kk-1)+hour_all;
           
               for k_hour=k_hour_start:k_hour_shag:k_hour_finish;   % hour-loop
                
                point_abs=nn(k_hour);
                for k_buy=handles.N_buy,     % buoy-loop                                         
                    if ((handles.Traj_time(k_buy,1)<=point_abs)&(handles.Traj_time(k_buy,2)>=point_abs)), % "the very" traj
                        point_otn=point_abs-handles.Traj_time(k_buy,1)+1;                        
                        
                        
                        if get(handles.SelectRegion,'Value')==1, % ====================================== "ellipse" visualization    

                            for k_buy=handles.N_buy,     % buoy-loop                                         
                                if ((handles.Traj_time(k_buy,1)<=point_abs)&(handles.Traj_time(k_buy,2)>=point_abs)), % "the very" traj
                                    point_otn=point_abs-handles.Traj_time(k_buy,1)+1;                                                
                                    axes(handles.axes1)
                                    x=handles.Traj_data{k_buy}(point_otn,4);
                                    y=handles.Traj_data{k_buy}(point_otn,5);
                                    u=handles.Traj_data{k_buy}(point_otn,11); 
                                    v=handles.Traj_data{k_buy}(point_otn,12);    
                                    if inpolygon(x,y,handles.x,handles.y),   
                                        if isnan(v)==0,
                                        U=[U u]; V=[V v];
                                        MU=mean(U(1:chislo)); MV=mean(V(1:chislo));
                                        UU=U(1:chislo)-MU; VV=V(1:chislo)-MV;
                                        MU2=mean(UU.^2); MV2=mean(VV.^2);
                                        MUV=mean(UU.*VV);
D=sqrt((MV2+MU2).^2-4.*(MU2.*MV2-MUV.^2));
lams(1)=.5.*(MV2+MU2+D);
lams(2)=.5.*(MV2+MU2-D);                          
                                        Aaxis=sqrt(lams(1));
                                        Baxis=sqrt(lams(2));
                                        if (MV2-MU2)~=0,
                                        
                                            Bangle=2.*MUV./(MV2-MU2);
                                            Theta=0.5.*atan(Bangle);
                                            COSA=cos(Theta); SINA=sin(Theta);
                                            %===========================
                                            x_base=handles.MULTI_ellipse.*handles.SELS.*Baxis.*cos(theta);      
                                            y_base=handles.MULTI_ellipse.*handles.SELS.*Aaxis.*sin(theta); 
                                            x_ell=handles.x0+x_base*COSA-y_base*SINA;
                                            y_ell=handles.y0+x_base*SINA+y_base*COSA;
                                            set(ell,'XData',x_ell,'YData',y_ell);
                                            [STRELAx,STRELAy]=strelka(handles.x0,handles.y0,MV,MU,handles.chisloA,0.25,20);
                                            set(arr,'XData',STRELAx,'YData',STRELAy);        
                                        end;
                                            chislo=chislo+1;  
                                            %                                        end;
                                        end;
                                    end;                                                                                  
                                end;
                            end;
                        else                        % ====================================== "trajectory" visualization                                                                           
                            IJK=CONTROL(k_buy)+1;
                            if IJK<=1,  % first point of trajectory
            

%                                set(handles.LIST,'String',int2str(handles.m(k_buy)));
                                handles.Buoy_start(k_buy)=point_otn;
                                handles.X=handles.Traj_data{k_buy}(point_otn,4); 
                                handles.Y=handles.Traj_data{k_buy}(point_otn,5); 
                                handles.Z=zeros(size(handles.Y))+handles.m(k_buy);   
                                guidata(gcbo,handles)               
                                body(k_buy)=line('Color',handles.Traj_data{k_buy}(point_otn,ColorNumber),...
                                    'LineStyle','-','Marker','.','MarkerSize',2,...
                                    'Erase','none','LineWidth',1,'XData',[],'YData',[],'ZData',[]);
                            else
                                handles.Buoy_finish(k_buy)=point_otn;
                                   
                                handles.X=[handles.X handles.Traj_data{k_buy}(point_otn,4)]; 
                                handles.Y=[handles.Y handles.Traj_data{k_buy}(point_otn,5)]; 
                                handles.Z=[handles.Z zeros(size(handles.Y))+handles.m(k_buy)];                                                       
                                guidata(gcbo,handles)                                    
                                XXX=handles.Traj_data{k_buy}(point_otn-handles.K:point_otn,2);
                                YYY=handles.Traj_data{k_buy}(point_otn-handles.K:point_otn,3);
                                XY=isnan(XXX);
                                XXX(XY==1)=[];
                                YYY(XY==1)=[];
                                XX{k_buy}=[XX0{k_buy}; XXX];
                                YY{k_buy}=[YY0{k_buy}; YYY];
                                set(body(k_buy),'Color',handles.Traj_data{k_buy}(point_otn,ColorNumber),...
                                    'XData',XX{k_buy},...
                                    'YData',YY{k_buy});
                                XX0{k_buy}=XXX;
                                YY0{k_buy}=YYY;
                                %                               else % main part of trajectory
%                                handles.Buoy_finish(k_buy)=point_otn;
%                                handles.X=[handles.X handles.Traj_data{k_buy}(point_otn,4)]; 
%                                handles.Y=[handles.Y handles.Traj_data{k_buy}(point_otn,5)]; 
%                                handles.Z=[handles.Z zeros(size(handles.Y))+handles.m(k_buy)];                                                       
%                                guidata(gcbo,handles)                                    
%                                set(body(k_buy),'Color',handles.Traj_data{k_buy}(point_otn,ColorNumber),...
%                                    'XData',handles.Traj_data{k_buy}(point_otn-handles.K:point_otn,4),...
%                                    'YData',handles.Traj_data{k_buy}(point_otn-handles.K:point_otn,5));                                                                                                          
                                %                                end;
                            end; % end of single trajectory
                            CONTROL(k_buy)=IJK;                
                        end; % end of "trajectory" visualization
                    end;  % end of "the very" trajectory
                end;    % end of buoy-loop
                drawnow
            end;   % end of hour-loop
        end;     % end of day-loop
    end;      % end of month-loop
end;        % end fo year-loop

if get(handles.SelectRegion,'Value')==0,
    cla
    basa_coast_old(handles.SLOall, handles.SLO100, handles.SLO500, handles.SLO1000, handles.GRAN1, handles.GRAN2,handles.XY)
    hold on
    
    for k_buy=handles.N_buy,
        if ((handles.Buoy_start(k_buy)~=0)&(handles.Buoy_finish(k_buy)~=0)),
            %     delete(body(k_buy))
            plot(handles.Traj_data{k_buy}(handles.Buoy_start(k_buy):handles.Buoy_finish(k_buy),2),...
                handles.Traj_data{k_buy}(handles.Buoy_start(k_buy):handles.Buoy_finish(k_buy),3),':',...
                'Color', (handles.Traj_data{k_buy}(1,16:18)))
            set(handles.text(k_buy),'Color',handles.Traj_data{k_buy}(1,16:18));
            
        end;
    end;
    drawnow
end;



else     % visualization by drifter

    STS=get(handles.BuoyList,'Value');
    N_b=STS;    
   
    Time_total=handles.Traj_time(N_b,2)-handles.Traj_time(N_b,1)+1;
    TTT=datevec(fix((handles.Traj_time(N_b,1):handles.Traj_time(N_b,2))./24)+datenum(1992,01,01,0,0,0)+2);
    TTT_min=TTT(1,:);
    TTT_max=TTT(end,:);
    
    handles.Year_start=TTT_min(1);
    set(handles.StartYear,'Value',TTT_min(1)-1991);
    handles.Month_start=TTT_min(2);
    set(handles.StartMonth,'Value',TTT_min(2));
    handles.Day_start=TTT_min(3);
    set(handles.StartDay,'String',int2str(TTT_min(3)));
    
    handles.Year_finish=TTT_max(1);
    set(handles.FinishYear,'Value',TTT_max(1)-1991);
    handles.Month_finish=TTT_max(2);
    set(handles.FinishMonth,'Value',TTT_max(2));
    handles.Day_finish=TTT_max(3);
    set(handles.FinishDay,'String',int2str(TTT_max(3)));
    
    XNAN=handles.Traj_data{N_b}(isnan(handles.Traj_data{N_b}(:,2))==0,2);
    YNAN=handles.Traj_data{N_b}(isnan(handles.Traj_data{N_b}(:,2))==0,3);
    CNAN=handles.Traj_data{N_b}(isnan(handles.Traj_data{N_b}(:,2))==0,ColorNumber);
    TNAN=TTT(isnan(handles.Traj_data{N_b}(:,2))==0,:);
    
%    p_single=line('Color',handles.Traj_data{N_b}(1,ColorNumber),...
%        'LineStyle','-','LineWidth',1,'Marker','.','MarkerSize',2,...
%        'XData',handles.Traj_data{N_b}(1:handles.K,2),'YData',handles.Traj_data{N_b}(1:handles.K,3),...
%            'EraseMode','none');
    p_single=line('Color',CNAN(1,:),...
        'LineStyle','-','LineWidth',1,'Marker','.','MarkerSize',2,...
        'XData',XNAN(1),'YData',YNAN(1),...
            'EraseMode','none');
        
        
%    for uu=handles.K+1:Time_total,
    for uu=2:length(XNAN),
        if get(handles.SpeedLow,'Value')==1,
            for s=1:100000,
                a=1;
                b=2;
            end;
        end;

%                set(p_single,'Color',handles.Traj_data{N_b}(uu,ColorNumber),...
%                    'XData',handles.Traj_data{N_b}(uu-handles.K:uu,2),...
%                    'YData',handles.Traj_data{N_b}(uu-handles.K:uu,3))%
%
%                datas1=int2str(TTT(uu,1));
%                datas0=int2str(TTT(uu,3));
%                if TTT(uu,3)<10,
%                    datas0=['0' datas0];
%                end;
%                datas2=[handles.MONTHS{TTT(uu,2)} ' ' datas0];
%                set(handles.CurrentYear,'String',datas1);
%                set(handles.CurrentDate,'String',datas2);
                set(p_single,'Color',CNAN(uu,:),...
                    'XData',XNAN(uu-1:uu),...
                    'YData',YNAN(uu-1:uu))

                datas1=int2str(TNAN(uu,1));
                datas0=int2str(TNAN(uu,3));
                if TNAN(uu,3)<10,
                    datas0=['0' datas0];
                end;
                datas2=[handles.MONTHS{TNAN(uu,2)} ' ' datas0];
                set(handles.CurrentYear,'String',datas1);
                set(handles.CurrentDate,'String',datas2);


                        drawnow


    end;
    refresh
                set(p_single,'Color',(handles.Traj_data{N_b}(1,16:18)).^.5,...
                    'XData',handles.Traj_data{N_b}(:,2),...
                    'YData',handles.Traj_data{N_b}(:,3),'LineWidth',1,'LineStyle','-')

    drawnow
    
end; % end of visualization

                            set (handles.SelectRegion,'Value',0);
guidata(gcbo,handles)
 %                           save test_uv U V 
%if exist('U'),
%    save 'c:\TMARGOLINA\DATAS\ellips_uv' U V Aaxis Baxis MU2 MV2
%end;



% --------------------------------------------------------------------
function varargout = PushExit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PushExit.
%disp('PushExit Callback not implemented yet.')

%pause off
%uiresume(handles.figure1)
delete(handles.figure1)

% --------------------------------------------------------------------
function varargout = SpeedLow_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.SpeedLow.
%disp('SpeedLow Callback not implemented yet.')

%handles.SpeedLow


guidata(gcbo,handles)


% --------------------------------------------------------------------
function varargout = StartMonth_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.StartMonth.
%disp('StartMonth Callback not implemented yet.')
%handles.Month_start=get(handles.StartMonth,'Value');
guidata(gcbo,handles)

% --------------------------------------------------------------------
function varargout = StartYear_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.StartYear.
%disp('StartYear Callback not implemented yet.')
%handles.Year_start=get(handles.StartYear,'Value')+1998;
guidata(gcbo,handles)

% --------------------------------------------------------------------
function varargout = StartDay_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.StartDay.
%disp('StartDay Callback not implemented yet.')

%handles.Day_start=str2num(get(handles.StartDay,'String'));
guidata(gcbo,handles)

% --------------------------------------------------------------------
function varargout = FinishMonth_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.FinishMonth.
%disp('StartMonth Callback not implemented yet.')
%handles.Month_final=get(handles.FinishMonth,'Value');
guidata(gcbo,handles)

% --------------------------------------------------------------------
function varargout = FinishYear_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.FinishYear.
%disp('StartYear Callback not implemented yet.')
%handles.Year_final=get(handles.FinishYear,'Value')+1998;
guidata(gcbo,handles)

% --------------------------------------------------------------------
function varargout = FinishDay_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.StartDay.
%disp('StartDay Callback not implemented yet.')

%handles.Day_final=str2num(get(handles.FinishDay,'String'));

guidata(gcbo,handles)

% --------------------------------------------------------------------
function varargout = PushClear_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.PushClear.
%disp('PushClear Callback not implemented yet.')

axes(handles.axes1)
hold off


cla
set(handles.axes1,'Visible','Off') 




guidata(gcbo,handles)


% --------------------------------------------------------------------
function varargout = BuoyList_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.BuoyList.
%disp('BuoyList Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = SelectBuoy_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.SelectBuoy.
%disp('SelectBuoy Callback not implemented yet.')


guidata(gcbo,handles)


%====================================================================
%====================================================================

function basa_coast_old(SLOall,SLO100, SLO500, SLO1000, GRAN1, GRAN2,XY) 

axesm('MapProjection','Mercator','FLatLimit',[30 50],'FLonLimit',[-136 -120],...
    'MLineLocation',-136:2:-120,'PLineLocation',30:2:50,'Grid','on','gcolor',[.7 .7 .7],...
    'MeridianLabel','on','ParallelLabel','on','MLabelLocation',-134:4:-122)
framem('FlineWidth',2,'FEdgeColor',[.7 .7 .7])
set(gca,'XLim',[-2.4 -2.1],'YLim',[0.55 1.01])
hidem(gca)
h=fillm(SLOall(2,:),SLOall(1,:),[.9 .9 .9]);
set(h,'EdgeColor',[.9 .9 .9])
hold on
h=fillm(SLO1000(2,:),SLO1000(1,:),[0.85 .85 .85]);
set(h,'EdgeColor',[.85 .85 .85])
h=fillm(SLO500(2,:),SLO500(1,:),[0.8 .8 .8]);
set(h,'EdgeColor',[.8 .8 .8])
h=fillm(SLO100(2,:),SLO100(1,:),[0.75 .75 .75]);
set(h,'EdgeColor',[.75 .75 .75])
h=fillm(GRAN1(2,:),GRAN1(1,:),[.5 .5 .5]);
set(h,'LineStyle','none');
h=fillm(GRAN2(2,:),GRAN2(1,:),[0.5 0.5 0.5]);
set(h,'LineStyle','none');


%==========================================================================
%==========================================================================

function traces(hObject,eventdata,handles)

XL=get(gca,'xlim'); YL=get(gca,'ylim'); 

point0=get(gca,'CurrentPoint');
x0=point0(1,1);
y0=point0(1,2);

INSIDE=inpolygon(x0,y0,[XL(1) XL(2) XL(2) XL(1) XL(1)],[YL(1) YL(1) YL(2) YL(2) YL(1)]);
if INSIDE,
    set(gcf,'Pointer','Custom','PointerShapeCData',handles.Pointer,'PointerShapeHotSpot',[9 9]);
else
    set(gcf,'Pointer','arrow')
end

SaveUnits=get(gca,'Units'); 
set(gca,'Units','Pixels');
POSITION=get(gca,'Position');
set(gca,'Units',SaveUnits);

dx=(XL(2)-XL(1))./POSITION(3); dy=(YL(2)-YL(1))./POSITION(4);

VEC1=handles.X.*dy+sqrt(-1).*handles.Y.*dx; VEC2=x0.*dy+sqrt(-1).*y0.*dx;

Dis=abs(VEC1-VEC2);
numb=find(Dis==min(Dis));
if ~isempty(numb),
    if INSIDE,
        set(handles.BuoyInformation,'String',sprintf('Trace # %d; point (%.2f, %.2f)',[handles.Z(numb(1)) handles.X(numb(1)) handles.Y(numb(1))]));
    else
        set(handles.BuoyInformation,'String','Wait for input...');
    end;
end;

guidata(hObject, handles);



function kliks(hObject,eventdata,handles)

XL=get(gca,'xlim'); YL=get(gca,'ylim'); 

point0=get(gca,'CurrentPoint');
x0=point0(1,1);
y0=point0(1,2);

INSIDE=inpolygon(x0,y0,[XL(1) XL(2) XL(2) XL(1) XL(1)],[YL(1) YL(1) YL(2) YL(2) YL(1)]);

SaveUnits=get(gca,'Units'); 
set(gca,'Units','Pixels');
POSITION=get(gca,'Position');
set(gca,'Units',SaveUnits);

dx=(XL(2)-XL(1))./POSITION(3); dy=(YL(2)-YL(1))./POSITION(4);

VEC1=handles.X.*dy+sqrt(-1).*handles.Y.*dx; VEC2=x0.*dy+sqrt(-1).*y0.*dx;

Dis=abs(VEC1-VEC2);
numb=find(Dis==min(Dis));
if ~isempty(numb),
    if INSIDE,
        set(handles.BuoyInformation,'String',sprintf('TRACE # %d',handles.Z(numb(1))));
    else
        set(handles.BuoyInformation,'String','Wait for input...');
    end;
end;

guidata(hObject, handles);
% =========================================================================

% --- Executes on button press in TraceBuoy.
function TraceBuoy_Callback(hObject, eventdata, handles)
% hObject    handle to TraceBuoy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of TraceBuoy

set(gcf,'WindowButtonMotionFcn',{@traces,handles});
set(gcf,'WindowButtonUpFcn',{@kliks,handles});
guidata(gcbo,handles)


% --- Executes during object creation, after setting all properties.
function BuoyInformation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to BuoyInformation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function BuoyInformation_Callback(hObject, eventdata, handles)
% hObject    handle to BuoyInformation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of BuoyInformation as text
%        str2double(get(hObject,'String')) returns contents of BuoyInformation as a double



% --- Executes during object creation, after setting all properties.
function colormap_list_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colormap_list (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in colormap_list.
function colormap_list_Callback(hObject, eventdata, handles)
% hObject    handle to colormap_list (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns colormap_list contents as cell array
%        contents{get(hObject,'Value')} returns selected item from colormap_list
set(handles.colormap_edit,'String',handles.Colormap_names{get(handles.colormap_list,'Value')});
if get(handles.colormap_colorbar,'Value'),
    axes(handles.colorbar_axes)
    colormap(get(handles.colormap_edit,'String'));
end;

guidata(hObject, handles);


% --- Executes on button press in colormap_colorbar.
function colormap_colorbar_Callback(hObject, eventdata, handles)
% hObject    handle to colormap_colorbar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of colormap_colorbar
temp=get(handles.colorbar_temp_check,'Value');
pres=get(handles.colorbar_pressure_check,'Value');
priz=temp+pres;
if (priz==0),
    set(hObject,'Value',0);
    errordlg('SELECT FEATURE FIRST','error')
else
    if temp,
        colormin=get(handles.temperature_edit_min,'Value');
        colormax=get(handles.temperature_edit_max,'Value');
    else
        colormin=get(handles.pressure_edit_min,'Value');
        colormax=get(handles.pressure_edit_max,'Value');
    end;            
    
    if get(hObject,'Value'),
        axes(handles.colorbar_axes)
        set(handles.colorbar_axes,'Visible','on');    
        colormap(get(handles.colormap_edit,'String'));
        if ~isfield(handles,'COLOR')            
            colorbar(handles.colorbar_axes);
            handles.COLOR=get(handles.colorbar_axes,'Children');
        else
            set(handles.COLOR,'Visible','On');
        end;
        if colormin<colormax,
            set(handles.colorbar_axes,'XLim',[colormin colormax]);
            set(handles.COLOR,'XData',[colormin colormax]);
            
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(colormin,colormax,length(cmap));
ijk=find((handles.ALL<=colormax)&(handles.ALL>=colormin));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        else
            errordlg('MIN > MAX','error')
        end;  
    else
        set(handles.colorbar_axes,'Visible','off');
        set(handles.COLOR,'Visible','Off');
    end;
end;

        


guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function colormap_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colormap_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function colormap_edit_Callback(hObject, eventdata, handles)
% hObject    handle to colormap_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of colormap_edit as text
%        str2double(get(hObject,'String')) returns contents of colormap_edit as a double

if get(handles.colormap_colorbar,'Value'),
    axes(handles.colorbar_axes)
    colormap(get(handles.colormap_edit,'String'));
end;
guidata(hObject, handles);

% --- Executes on button press in colorbar_temp_check.
function colorbar_temp_check_Callback(hObject, eventdata, handles)
% hObject    handle to colorbar_temp_check (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of colorbar_temp_check

set(handles.colorbar_pressure_check,'Value',0);

p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_temp_check,'Value');
if (p1)&(p2),
    t_min=get(handles.temperature_edit_min,'Value');
    t_max=get(handles.temperature_edit_max,'Value');
    if t_min<t_max,
        set(handles.colorbar_axes,'XLim',[t_min t_max]);
        set(handles.COLOR,'XData',[t_min t_max]);
                
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(t_min,t_max,length(cmap));
ijk=find((handles.ALL<=t_max)&(handles.ALL>=t_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               

    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);


% --- Executes on button press in colorbar_pressure_check.
function colorbar_pressure_check_Callback(hObject, eventdata, handles)
% hObject    handle to colorbar_pressure_check (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of colorbar_pressure_check

set(handles.colorbar_temp_check,'Value',0);

p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_pressure_check,'Value');
if (p1)&(p2),
    p_min=get(handles.pressure_edit_min,'Value');
    p_max=get(handles.pressure_edit_max,'Value');
    if p_min<p_max,
        set(handles.colorbar_axes,'XLim',[p_min p_max]);
        set(handles.COLOR,'XData',[p_min p_max]);

%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(p_min,p_max,length(cmap));
ijk=find((handles.ALL<=p_max)&(handles.ALL>=p_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               

    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function temperature_minimum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to temperature_minimum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on slider movement.
function temperature_minimum_Callback(hObject, eventdata, handles)
% hObject    handle to temperature_minimum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
t_min=get(hObject,'Value');
set(handles.temperature_edit_min,'Value',t_min,'String',num2str(t_min));
p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_temp_check,'Value');
if (p1)&(p2),
    t_max=get(handles.temperature_edit_max,'Value');
    if t_min<t_max,
        set(handles.colorbar_axes,'XLim',[t_min t_max]);
        set(handles.COLOR,'XData',[t_min t_max]);
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(t_min,t_max,length(cmap));
ijk=find((handles.ALL<=t_max)&(handles.ALL>=t_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function temperature_maximum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to temperature_maximum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on slider movement.
function temperature_maximum_Callback(hObject, eventdata, handles)
% hObject    handle to temperature_maximum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
t_max=get(hObject,'Value');
set(handles.temperature_edit_max,'Value',t_max,'String',num2str(t_max));
p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_temp_check,'Value');
if (p1)&(p2),
    t_min=get(handles.temperature_edit_min,'Value');
    if t_min<t_max,
        set(handles.colorbar_axes,'XLim',[t_min t_max]);
        set(handles.COLOR,'XData',[t_min t_max]);
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(t_min,t_max,length(cmap));
ijk=find((handles.ALL<=t_max)&(handles.ALL>=t_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function pressure_minimum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pressure_minimum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on slider movement.
function pressure_minimum_Callback(hObject, eventdata, handles)
% hObject    handle to pressure_minimum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

p_min=get(hObject,'Value');
set(handles.pressure_edit_min,'Value',p_min,'String',num2str(p_min));
p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_pressure_check,'Value');
if (p1)&(p2),
    p_max=get(handles.pressure_edit_max,'Value');
    if p_min<p_max,
        set(handles.colorbar_axes,'XLim',[p_min p_max]);
        set(handles.COLOR,'XData',[p_min p_max]);
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(p_min,p_max,length(cmap));
ijk=find((handles.ALL<=p_max)&(handles.ALL>=p_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function pressure_maximum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pressure_maximum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on slider movement.
function pressure_maximum_Callback(hObject, eventdata, handles)
% hObject    handle to pressure_maximum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

p_max=get(hObject,'Value');
set(handles.pressure_edit_max,'Value',p_max,'String',num2str(p_max));
p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_pressure_check,'Value');
if (p1)&(p2),
    p_min=get(handles.pressure_edit_min,'Value');
    if p_min<p_max,
        set(handles.colorbar_axes,'XLim',[p_min p_max]);
        set(handles.COLOR,'XData',[p_min p_max]);
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(p_min,p_max,length(cmap));
ijk=find((handles.ALL<=p_max)&(handles.ALL>=p_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;          
end;

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function temperature_edit_min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to temperature_edit_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function temperature_edit_min_Callback(hObject, eventdata, handles)
% hObject    handle to temperature_edit_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of temperature_edit_min as text
%        str2double(get(hObject,'String')) returns contents of temperature_edit_min as a double

pp=get(handles.temperature_edit_min,'String');

if ~strcmp(pp,'auto'),
    set(handles.temperature_edit_min,'Value',str2num(pp));
end;

p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_temp_check,'Value');
if (p1)&(p2),
    t_min=get(handles.temperature_edit_min,'Value');
    t_max=get(handles.temperature_edit_max,'Value');
    if t_min<t_max,
        set(handles.colorbar_axes,'XLim',[t_min t_max]);
        set(handles.COLOR,'XData',[t_min t_max]);
        set(handles.temperature_minimum,'Value',str2num(pp));
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(t_min,t_max,length(cmap));
ijk=find((handles.ALL<=t_max)&(handles.ALL>=t_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function temperature_edit_max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to temperature_edit_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function temperature_edit_max_Callback(hObject, eventdata, handles)
% hObject    handle to temperature_edit_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of temperature_edit_max as text
%        str2double(get(hObject,'String')) returns contents of temperature_edit_max as a double

pp=get(handles.temperature_edit_max,'String');

if ~strcmp(pp,'auto'),
    set(handles.temperature_edit_max,'Value',str2num(pp));
end;

p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_temp_check,'Value');
if (p1)&(p2),
    t_min=get(handles.temperature_edit_min,'Value');
    t_max=get(handles.temperature_edit_max,'Value');
    if t_min<t_max,
        set(handles.colorbar_axes,'XLim',[t_min t_max]);
        set(handles.COLOR,'XData',[t_min t_max]);
        set(handles.temperature_maximum,'Value',str2num(pp));
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(t_min,t_max,length(cmap));
ijk=find((handles.ALL<=t_max)&(handles.ALL>=t_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function pressure_edit_min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pressure_edit_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function pressure_edit_min_Callback(hObject, eventdata, handles)
% hObject    handle to pressure_edit_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pressure_edit_min as text
%        str2double(get(hObject,'String')) returns contents of pressure_edit_min as a double

pp=get(handles.pressure_edit_min,'String');

if ~strcmp(pp,'auto'),
    set(handles.pressure_edit_min,'Value',str2num(pp));
end;


p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_pressure_check,'Value');
if (p1)&(p2),
    p_min=get(handles.pressure_edit_min,'Value');
    p_max=get(handles.pressure_edit_max,'Value');
    if p_min<p_max,
        set(handles.colorbar_axes,'XLim',[p_min p_max]);
        set(handles.COLOR,'XData',[p_min p_max]);
        set(handles.pressure_minimum,'Value',str2num(pp));    
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(p_min,p_max,length(cmap));
ijk=find((handles.ALL<=p_max)&(handles.ALL>=p_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;      
end;

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function pressure_edit_max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pressure_edit_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function pressure_edit_max_Callback(hObject, eventdata, handles)
% hObject    handle to pressure_edit_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pressure_edit_max as text
%        str2double(get(hObject,'String')) returns contents of pressure_edit_max as a double


pp=get(handles.pressure_edit_max,'String');

if ~strcmp(pp,'auto'),
    set(handles.pressure_edit_max,'Value',str2num(pp));
end;

p1=get(handles.colormap_colorbar,'Value');
p2=get(handles.colorbar_pressure_check,'Value');
if (p1)&(p2),
    p_min=get(handles.pressure_edit_min,'Value');
    p_max=get(handles.pressure_edit_max,'Value');
    if p_min<p_max,
        set(handles.colorbar_axes,'XLim',[p_min p_max]);
        set(handles.COLOR,'XData',[p_min p_max]);
        set(handles.pressure_maximum,'Value',str2num(pp));
%========================================================
cmap=colormap;
if get(handles.colorbar_pressure_check,'Value')==1,
    handles.ALL=handles.PRE;
    handles.LL=handles.PP;
end;
if get(handles.colorbar_temp_check,'Value')==1,
    handles.ALL=handles.TEM;
    handles.LL=handles.TT;
end;

x=1:length(handles.ALL); x=x';
C=linspace(p_min,p_max,length(cmap));
ijk=find((handles.ALL<=p_max)&(handles.ALL>=p_min));
handles.COLORES=zeros(3,length(handles.ALL))+handles.NoColor'*ones(size(handles.ALL));
handles.COLORES(:,ijk)=spline(C,cmap',handles.ALL(ijk));
handles.COLORES(handles.COLORES>1)=1;
handles.COLORES(handles.COLORES<0)=0;
for k=1:handles.M_buy,
    handles.Traj_data{k}(:,13:15)=handles.COLORES(:,handles.LL(k,1):handles.LL(k,2))';
end;
%========================================================                                                                               
        
    else
        errordlg('MIN > MAX','error')
    end;  
end;

guidata(hObject, handles);


% --- Executes on button press in SelectRegion.
function SelectRegion_Callback(hObject, eventdata, handles)
% hObject    handle to SelectRegion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(handles.SelectRegion,'Value')==1,
    set(handles.SelectBuoy,'Value',0)
    axes(handles.axes1);
    set(handles.axes1,'Visible','On') 
    basa_coast_old(handles.SLOall, handles.SLO100, handles.SLO500, handles.SLO1000, handles.GRAN1, handles.GRAN2,handles.XY)
    hold on
    k=waitforbuttonpress;
    Point1=get(gca,'CurrentPoint');
    finalRect=rbbox;
    Point2=get(gca,'CurrentPoint');
    point1=Point1(1,1:2);
    point2=Point2(1,1:2);
    p1=min(point1,point2);
    offset=abs(point1-point2);
    handles.x=[p1(1) p1(1)+offset(1) p1(1)+offset(1) p1(1) p1(1)];
    handles.y=[p1(2) p1(2) p1(2)+offset(2) p1(2)+offset(2) p1(2)];
    handles.x0=point1(1)+0.5*offset(1);
    handles.y0=point2(2)+0.5*offset(2);
    handles.center=plot(handles.x0,handles.y0,'ko','MarkerSize',4,'MarkerFaceColor','w');
    handles.ramka=plot(handles.x,handles.y,':k');
end;
guidata(hObject, handles);


function [STRELAx,STRELAy]=strelka(x,y,v,u,chisloA,chisloB,BETA);

% chisloA - multiplayer for velocity
% chisloB - multiplayer for feathering
% BETA    - angle of feathering

% length of whole velocity vector
chisloD=sqrt(u.^2+v.^2).*chisloA;
% approximate length of feathering
chisloB=chisloD.*chisloB;

chisloC=chisloB.*tan(BETA*pi/180);

% form arrow "body"

BASAx=[x x+chisloA.*v];
BASAy=[y y+chisloA.*u];

% form feathering prior to rotation

strelkaXa=[BASAx(1)+chisloD BASAx(1)+chisloD-chisloB];
strelkaYa=[BASAy(1) BASAy(1)+chisloC];

strelkaXb=[BASAx(1)+chisloD BASAx(1)+chisloD-chisloB];
strelkaYb=[BASAy(1) BASAy(1)-chisloC];

% rotation of feathering
ANGLES=atan(abs(u./v));

if (v<0)&(u<0),
    ANGLES=pi+ANGLES;
end;
if (v>0)&(u<0),
    ANGLES=2*pi-ANGLES;
end;
if (v<0)&(u>0),
    ANGLES=pi-ANGLES;
end;
xn=strelkaXa-BASAx(1);
yn=strelkaYa-BASAy(1);
strelkaXa=BASAx(1)+xn.*cos(ANGLES)-yn.*sin(ANGLES);
strelkaYa=BASAy(1)+xn.*sin(ANGLES)+yn.*cos(ANGLES);

xn=strelkaXb-BASAx(1);
yn=strelkaYb-BASAy(1);
strelkaXb=BASAx(1)+xn.*cos(ANGLES)-yn.*sin(ANGLES);
strelkaYb=BASAy(1)+xn.*sin(ANGLES)+yn.*cos(ANGLES);


STRELAx=[BASAx NaN strelkaXa NaN strelkaXb];
STRELAy=[BASAy NaN strelkaYa NaN strelkaYb];
